
#property indicator_separate_window
#property indicator_buffers    2
#property indicator_color1     Blue
#property indicator_color2     Red
#property indicator_level1     100
#property indicator_level2     -100
#property indicator_levelcolor Yellow

//
//
//
//
//

extern int    CCI_Price        = 5;
extern double Alpha            = 0.07;

extern bool   alertsOn         = false;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;
extern bool   alertsNotify     = false;
extern string soundFile        = "alert2.wav";
extern bool   ShowArrows       = false;
extern string arrowsIdentifier = "cciCycle Arrows1";
extern double arrowsUpperGap   = 1.0;
extern double arrowsLowerGap   = 1.0;
extern color  arrowsUpColor    = LimeGreen;
extern color  arrowsDnColor    = Red;
extern int    arrowsUpCode     = 241;
extern int    arrowsDnCode     = 242;

//
//
//
//
//

double Cycle[];
double Trigger[];
double Smooth[];
double P[];
double trend[];

//
//
//
//
//

int init() 
{
    IndicatorBuffers(5);
    SetIndexBuffer(0,Cycle);
    SetIndexBuffer(1,Trigger);
    SetIndexBuffer(2,Smooth);
    SetIndexBuffer(3,P);
    SetIndexBuffer(4,trend);
    IndicatorShortName("cci  Adaptive Cyber Cycle  [" + DoubleToStr(Alpha, 2) + "]");
return (0);
}
int deinit() 
{  
   deleteArrows(); 
return(0); 
}

//
//
//
//
//
  
int start() 
{
    int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
    
    //
    //
    //
    //
    //
    
    for(int i=limit; i>=0; i--)
    {
        P[i]          = iMA(NULL,0,1,0,MODE_SMA,PRICE_MEDIAN,i);
        Smooth[i]     = (P[i] + 2.0 * P[i+1] + 2.0 * P[i+2] + P[i+3]) / 6.0;
        double period = iCustom(NULL,0,"CyclePeriod nmc",Alpha,0,i);
        Cycle[i]      = iCCI(NULL,0,period,CCI_Price,i);           
        if (i > Bars - 8) 
        {
            Cycle[i] = (P[i] - 2.0 * P[i+1] + P[i+2]) / 4.0;
        }
        Trigger[i] = Cycle[i+1];
        trend[i]   = trend[i+1];
           if (Cycle[i]>Trigger[i]) trend[i] = 1;
           if (Cycle[i]<Trigger[i]) trend[i] =-1;
           
           //
           //
           //
           //
           //
     
           if (ShowArrows)
           {
             deleteArrow(Time[i]);
             if (trend[i] != trend[i+1])
             {
               if (trend[i] == 1)  drawArrow(i,arrowsUpColor,arrowsUpCode,false);
               if (trend[i] ==-1)  drawArrow(i,arrowsDnColor,arrowsDnCode, true);
             }
            }
   }
   
   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("crossed up");
      else  doAlert("crossed down");       
   }       
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," cci_AdaptiveCyberCycle ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," cci_AdaptiveCyberCycle "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}



